#include "boneco.h"
#include "defines.h"
#include "classe_jogo.h"
#include "colisao.h"
#include "globais.h"
#include "perseguir.h"
#include "ataque.h"
#include <iostream>
#include <string.h>
using std::cout;

boneco::boneco(char nome1[], int tipo_boneco, int pos_x, int pos_y, int vel_pulo, int vel_andar, int q_andar, int q_pular, int qnt_atacar, int distancia_corte, int distancia_corte_atacar, int altura, int grav, int l, int atq)
{
    //carregando sprites no array
    if( tipo_boneco == 0 ) cout << " \n\n########### INIMIGO #######\n";
    else if ( tipo_boneco == 1 ) cout << " \n\n########### PLAYER 1 #######\n";
    else if ( tipo_boneco ==2 ) cout << " \n\n########### PLAYER 2 #######\n";
    int tamanho_array, x = 1;
    BITMAP * todos;
    tamanho_array = 2 + 2*q_pular + 2*q_andar;

    while (!(imagens = new BITMAP*[tamanho_array+1]));
    while (!(ataque = new BITMAP*[qnt_atacar+1]));

    //carrega de os movimento

    cout << "to mexendo com : " << nome1 << "\n";

    todos = create_bitmap((tamanho_array*distancia_corte)+(qnt_atacar*2*distancia_corte_atacar),altura);
    cout << "oi\n";
    todos = load_bitmap(nome1, NULL);
    if ( todos == NULL ) cout << " load do bitmap deu pau \n";
    cout << "criei bitmap\n";

    while (x <= tamanho_array)
    {
        imagens[x] = create_bitmap(distancia_corte, altura);
        blit(todos, imagens[x], (x-1)*distancia_corte, 0, 0, 0, distancia_corte, altura);
        x++;
    }

    cout << "capturei bitmaps\n";

    //carrega os de ataque
    quant_ataque = qnt_atacar;
    int y = 0;
    while (y < qnt_atacar*2)
    {
        ////cout << (tamanho_array*distancia_corte)+(y*distancia_corte_atacar) << "\n";
        ataque[y] = create_bitmap(distancia_corte_atacar, altura);
        blit(todos, ataque[y], (tamanho_array*distancia_corte)+(y*distancia_corte_atacar), 0, 0, 0, distancia_corte_atacar, altura);
        y++;
    }

    cout << "capturei bitmaps de ataque\n";

    a = 0;

    strcpy(nome,nome1);

    nome[strlen(nome) - 4] = '\0';

    for (int x = 0; x < 4 ;x++)
        colisao[x] = 0;

    for (int x = 0; x < 10 ;x++)
        teclado[x] = 0;

    cout << "zerei vetor de colisao e movimento inimigo\n";

    posicao_array = -1;

    bmp = imagens[1]; //comea pra direita

    quant_andar = q_andar;
    quant_pular = q_pular;

    pulo.velocidade_inicial_y = vel_pulo;
    pulo.velocidade_inicial_x = vel_pulo;
    pulo.duracao = (float) 2*vel_pulo/grav;
    pulando = 0;

    velocidade_andar = vel_andar;

    posicao_x = pos_x;
    posicao_y = pos_y;



    if (tipo_boneco == 0)
    {
        posicao_x = MAX_X+100;
        posicao_y = MAX_Y-(rand()%300);
        cout << "inicializei inimigo no estagio\n";
    }

    margem_x = 15;
    margem_y = 15;

    tamanho_x = distancia_corte;
    tamanho_y = altura;

    tipo = tipo_boneco;

    pos_pular_d = 3;
    pos_pular_e = 3 + quant_pular;
    pos_andar_d = 3 + 2*quant_pular;
    pos_andar_e = 3 + 2*quant_pular + quant_andar;
    d = pos_andar_d;
    e = pos_andar_e;

    direcao = 1;

    atacando = 0;
    atacado = 0;
    caindo = 0;

    dano = atq;
    life = l;
    area_visao = rand()%MAX_X;
    while (area_visao < 400)
    {
        area_visao = rand()%MAX_X;
    }
    cout << "defini visao do inimigo\n";

    principal->array.inserir(this);
    cout << "inseri no array de objetos\n";
    install_param_int(movimento_boneco, (void *)this, 100);
    cout << "criei contador pra movimento boneco\n";
    if (tipo_boneco == 0)
    {
        install_param_int(perseguir, (void *)this, 100);
        cout << "mandei inimigo perseguir\n";
    }
    cout << "termino classe boneco\n#########################\n";
}

boneco::~boneco (void)
{
    //cout << "1\n";
    delete[] imagens;
    remove_param_int(movimento_boneco, (void *)this);
    if (tipo == 0)
    {
        remove_param_int(perseguir, (void *)this);
    }
    delete bmp;
    //cout << "2\n";
}

void movimento_boneco (void * parametro)
{
    boneco * personagem = (boneco*)parametro;

    colisao();

    clear_keybuf(); //Limpa o buffer do teclado

    if (principal->pausado)
        return;

    if (personagem->atacado)
    {
        if (!personagem->caindo)
        {
            if ( exibir_tela == false )
            {
                install_param_int(sofrer_ataque, (void*)personagem, 50);

                ////cout << personagem->nome << " atacado pela" << personagem->atacado << "\n";
                personagem->caindo = 1;
                return;
            }
        }
        else
            return;
    }

    if (TECLA_SOCO && !personagem->atacando)
    {
        //cout << "atacou\n";
        personagem->atacando = 1;
        install_param_int(atacar, (void*)personagem, 50);
        return;
    }

    if (personagem->atacando)
        return;

    if (personagem->pulando) //atualiza os sprites durante o pulo e o movimento do boneco caso teclas estejam apertadas
    {
        float tempo_sprite = personagem->pulo.duracao/personagem->quant_pular; //tempo que cada sprite de pulo vai ficar sendo exibido
        tempo_sprite /= 5;
        int sprite = (int)(personagem->pulo.tempo_decorrido/tempo_sprite); //qual sprite sera exibido

        if (personagem->direcao == 1)
        {
            personagem->bmp = personagem->imagens[personagem->pos_pular_d + sprite];
        }
        else
        {
            personagem->bmp = personagem->imagens[personagem->pos_pular_e + sprite];
        }
        if (TECLA_DIREITA)
        {
            (TECLA_CORRER) ? personagem->posicao_x += personagem->velocidade_andar*2 : personagem->posicao_x += personagem->velocidade_andar;
        }
        if (TECLA_ESQUERDA)
        {
            (TECLA_CORRER) ? personagem->posicao_x -= personagem->velocidade_andar*2 : personagem->posicao_x -= personagem->velocidade_andar;
        }
    }

    else if (!TECLA_PULAR) //se movimentando ou parado sem pular
    {
        //ATUALIZA A POSIO VERIFICANDO COLISAO
        if (TECLA_DIREITA && !personagem->colisao[0])
        {
            (TECLA_CORRER) ? personagem->posicao_x += personagem->velocidade_andar*2 : personagem->posicao_x += personagem->velocidade_andar;
        }
        else if (TECLA_ESQUERDA && !personagem->colisao[1])
        {
            (TECLA_CORRER) ? personagem->posicao_x -= personagem->velocidade_andar*2 : personagem->posicao_x -= personagem->velocidade_andar;
        }
        if (TECLA_CIMA && !personagem->colisao[2])
        {
            (TECLA_CORRER) ? personagem->posicao_y -= personagem->velocidade_andar*2 : personagem->posicao_y -= personagem->velocidade_andar;
        }
        else if (TECLA_BAIXO && !personagem->colisao[3])
        {
            (TECLA_CORRER) ? personagem->posicao_y += personagem->velocidade_andar*2 : personagem->posicao_y += personagem->velocidade_andar;
        }

        //ATUALIZA OS SPRITES, INDEPENDENTE DE POSIAO OU COLISAO
        if (TECLA_DIREITA)
        {
            personagem->direcao = 1;
            personagem->bmp = personagem->imagens[personagem->d];
            personagem->d++;
            if (personagem->d == personagem->pos_andar_e) //se chegar na posiao limite dos sprites de direita, reseta
            {
                personagem->d = personagem->pos_andar_d;
            }
        }
        else if (TECLA_ESQUERDA)
        {
            personagem->direcao = 2;
            personagem->bmp = personagem->imagens[personagem->e];
            personagem->e++;
            if (personagem->e == personagem->pos_andar_e + personagem->quant_andar-1) //se chegar na posiao limite dos sprites de esquerda, reseta
            {
                personagem->e = personagem->pos_andar_e;
            }
        }
        else if (TECLA_CIMA || TECLA_BAIXO)
        {
            if (personagem->direcao == 1) //se estiver virado pra direita usa os sprites de andar pra direita
            {
                personagem->bmp = personagem->imagens[personagem->d];
                personagem->d++;
                if (personagem->d == personagem->pos_andar_e) //se chegar na posiao limite dos sprites de direita, reseta
                {
                    personagem->d = personagem->pos_andar_d;
                }
            }
            else
            {
                personagem->bmp = personagem->imagens[personagem->e];
                personagem->e++;
                if (personagem->e == personagem->pos_andar_e + personagem->quant_andar-1) //se chegar na posiao limite dos sprites de esquerda, reseta
                {
                    personagem->e = personagem->pos_andar_e;
                }
            }
        }
        else //est em repouso
        {
            personagem->bmp = personagem->imagens[personagem->direcao];
        }
    }

    else if (TECLA_PULAR) //Se o personagem pular, andando ou parado
    {
        if (TECLA_DIREITA)
        {
            personagem->bmp = personagem->imagens[personagem->pos_pular_d];
            personagem->pulo.incremento_x = 1; //incrementa -> direita
        }

        else if (TECLA_ESQUERDA)
        {
            personagem->bmp = personagem->imagens[personagem->pos_pular_e];
            personagem->pulo.incremento_x = -1; //decrementa -> esquerda
        }

        else
        {
            personagem->bmp = personagem->imagens[personagem->direcao];
            personagem->pulo.incremento_x = 0; //soma com zero -> pula no lugar
        }

        personagem->pulando = 1;
        personagem->pulo.posicao_inicial_y = personagem->posicao_y;
        personagem->pulo.posicao_inicial_x = personagem->posicao_x;
        personagem->pulo.tempo_inicial = principal->tempo;

        install_param_int(pular, (void*)personagem, 30);
    }

    //para nao passar dos limites (direita, esquerda, baixo e o limite superior)
    if (personagem->posicao_x <= MAX_X && personagem->posicao_y <= MAX_Y) //se ja tiver entrado na tela nao pode sair mais
    {
        if (personagem->posicao_x < 0)
            personagem->posicao_x = 0;

        if (personagem->posicao_x > MAX_X - personagem->tamanho_x)
            personagem->posicao_x = MAX_X - personagem->tamanho_x;

        if (personagem->posicao_y > MAX_Y - personagem->tamanho_y)
            personagem->posicao_y = MAX_Y - personagem->tamanho_y;

        if (personagem->posicao_y + personagem->tamanho_y < principal->cenario->teto_fase && !personagem->pulando)
            personagem->posicao_y = principal->cenario->teto_fase - personagem->tamanho_y;
    }

    clear_keybuf();
}

void pular (void * parametro)
{
    boneco * personagem = (boneco*) parametro;

    personagem->posicao_x += personagem->pulo.incremento_x * 1;

    personagem->pulo.tempo_decorrido = principal->tempo - personagem->pulo.tempo_inicial;

    personagem->posicao_y = personagem->pulo.posicao_inicial_y - calc_posicao(personagem->pulo.velocidade_inicial_y, principal->gravidade, personagem->pulo.tempo_decorrido*5);

    if (personagem->posicao_y > personagem->pulo.posicao_inicial_y)
    {
        personagem->posicao_y = personagem->pulo.posicao_inicial_y;
        personagem->pulando = 0;
        remove_param_int(pular, (void*) parametro);
    }
}

int calc_posicao (int v_inicial, int gravidade, float tempo)
{
    return( (int) (v_inicial*tempo - (gravidade/2)*tempo*tempo) );
}
