#include "classe_allegro.h"
#include "defines.h"
#include <allegro.h>
#include <iostream>
using std::cout;

ALLEGRO::ALLEGRO()
{
    allegro_init();
    set_color_depth(desktop_color_depth());
    if (set_gfx_mode(GFX_AUTODETECT_WINDOWED, MAX_X, MAX_Y, 0, 0) < 0)
    {
        cout << "Erro ao inicializar o video\n";
        exit(1);
    }

//    if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) < 0)
//    {
//        cout << "Erro ao inicializar o som\n";
//        exit(1);
//    }
    install_timer();
    install_keyboard();
    install_mouse();
    set_window_title(TITULO_PROGRAMA);
}

ALLEGRO::~ALLEGRO()
{
    allegro_exit();
}
