#include "classe_jogo.h"
#include "conta_tempo.h"
#include "tela.h"
#include "logica.h"
#include "defines.h"
#include "menu.h"
#include "pula_fase.h"
#include "globais.h"

#include <iostream>
using std::cout;

jogo::jogo(int g, int type)
{
    exibir_tela = true;
    receber_ataque = false;

    posicao_p1 = 0;
    posicao_p2 = 1;

    tipo = type;

    buffer = create_bitmap(MAX_X, MAX_Y);
    tempo = 0;
    sair = 0;
    gravidade = g;

    while(!(cenario = new estagio("cenario2.bmp",1,530,3610,768)));

    inimigos_vivos = 0;
    quant_telas = 4;
    telas_exibidas = 0;

    pausado = 0;

    fase = 0;

    for (int x = 0 ; x < 100 ; x++)
    {
        array_logica[x] = 0;
    }

    install_int(funcoes_timer, 100);
}

jogo::~jogo()
{
    //cout << "3\n";
    remove_int(funcoes_timer);
    //cout << "\n";
}

void funcoes_timer (void)
{
    if (!principal->pausado)
    {
        conta_tempo();
        logica();
        if( receber_ataque == false )
        {
            tela();
        }
    }

    if (key[KEY_CAPSLOCK])
        pula_fase();

    if (key[KEY_PAUSE] && principal->pausado)
    {
        principal->pausado = 0;
    }
    else if (key[KEY_PAUSE] && !principal->pausado)
    {
        principal->pausado = 1;
    }

}
