#ifndef CLASSE_JOGO_H_INCLUDED
#define CLASSE_JOGO_H_INCLUDED

#include "classe_array.h"
#include "classe_estagio.h"

class jogo
{
public:
    jogo(int g, int type);
    ~jogo();
    ARRAY array;
    float tempo;
    BITMAP * buffer;
    estagio * cenario;
    int tipo; // 1 = Single ou 2 = Multiplayer ou 0 = game over
    int sair; //flag para fechar o jogo
    int gravidade;
    int array_logica[100];

    int posicao_p1; //posicao do player1 no array
    int posicao_p2; //posicao do player2 no array

    int inimigos_vivos;
    int quant_telas;
    int telas_exibidas;
    int fase;

    int pausado;

    boneco * novos_personagens[10];
};

void funcoes_timer (void);

#endif // CLASSE_JOGO_H_INCLUDED
