#include <allegro.h>
#include <iostream>
using std::cout;

#include "classe_jogo.h"
#include "globais.h"
#include "funcoes_allegro.h"
#include "menu.h"

int main (void)
{
    int estado;
    jogo * p;
    if (inicializar_allegro())
    {
        //cout << "Erro inicializando o allegro\n";
        exit(1);
    }

    estado = menu();
    if (estado == 5) // sair
    {
        allegro_exit();
        exit(0);
    }
    else if (estado == 2) //single
    {
        p = new jogo(70, 1);
    }
    else // multi
    {
        p = new jogo(70, 2);
    }

    principal = p;

    //arquivo, tipo, pos_x, pos_y, velocidade_andar, sprites andar, sprites pular, sprites atacar, distancia corte movimento, dist corte ataque, altura
    boneco personagem1("wolverine.bmp", 1, 5, 400, 150, 38, 6, 2, 6, 115, 167, 122, 70, 100, 15);
    boneco personagem2("sabretooth.bmp", 2, 5, 600, 130, 33, 5, 6, 4, 130, 136, 159, 70, 100, 20);

    if (estado == 2) //single
    {
        p->array.remover(&personagem2);
    }

    //checa se a tecla esc foi apertada a cada 500ms porque um while normal requer muito do processador
    while (!principal->sair)
    {
        rest(500);
    }

    //cout << "7\n";
    clear_keybuf();
    //cout << "7.5\n";
	allegro_exit();
    //cout << "8\n";

    return(0);
}
END_OF_MAIN()

